## kodi-inputstream-adaptive 21.5.16+ds

=== CMakeLists.txt ===
# cmake -DCMAKE_BUILD_TYPE=Debug ..
# cmake -DCMAKE_BUILD_TYPE=Release ..
if(MSVC)
  cmake_policy(SET CMP0091 NEW)
  cmake_minimum_required(VERSION 3.15)
else()
  cmake_minimum_required(VERSION 3.10)
endif()

function(get_bento4_version)
  file(STRINGS "Source/C++/Core/Ap4Version.h" _temp REGEX "AP4_VERSION_STRING")
  string(REGEX MATCH "\"([^\"]+)\"" _temp "${_temp}")
  set(BENTO4_VERSION "${CMAKE_MATCH_1}" PARENT_SCOPE)
endfunction()

get_bento4_version()
project(bento4 VERSION "${BENTO4_VERSION}")

# Variables
set(SOURCE_ROOT ${CMAKE_CURRENT_SOURCE_DIR}/Source/C++)
set(SOURCE_CODECS ${SOURCE_ROOT}/Codecs)
set(SOURCE_CORE ${SOURCE_ROOT}/Core)
set(SOURCE_CRYPTO ${SOURCE_ROOT}/Crypto)
set(SOURCE_METADATA ${SOURCE_ROOT}/MetaData)
set(SOURCE_SYSTEM ${SOURCE_ROOT}/System)

# Compiler warning and optimization flags
if(CMAKE_C_COMPILER_ID MATCHES "GNU")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wno-class-memaccess")
endif()

if (EMSCRIPTEN)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-warn-absolute-paths")
endif()

set(CMAKE_OSX_DEPLOYMENT_TARGET 10.12)

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_WARNINGS)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /GF /Gy /GR")
endif()

# AP4 Library
file(GLOB AP4_SOURCES
  ${SOURCE_CODECS}/*.cpp
  ${SOURCE_CORE}/*.cpp
  ${SOURCE_CRYPTO}/*.cpp
  ${SOURCE_METADATA}/*.cpp
  ${SOURCE_SYSTEM}/StdC/*.cpp
)

# Platform specifics
if(WIN32)
  set(AP4_SOURCES ${AP4_SOURCES} ${SOURCE_SYSTEM}/Win32/Ap4Win32Random.cpp)
else()
  set(AP4_SOURCES ${AP4_SOURCES} ${SOURCE_SYSTEM}/Posix/Ap4PosixRandom.cpp)
endif()

# Includes
set(AP4_INCLUDE_DIRS
  $<BUILD_INTERFACE:${SOURCE_CORE}>
  $<BUILD_INTERFACE:${SOURCE_CODECS}>
  $<BUILD_INTERFACE:${SOURCE_CRYPTO}>
  $<BUILD_INTERFACE:${SOURCE_METADATA}>
)
file(GLOB AP4_HEADERS
  ${SOURCE_CORE}/*.h
  ${SOURCE_CODECS}/*.h
  ${SOURCE_CRYPTO}/*.h
  ${SOURCE_METADATA}/*.h
)

add_library(ap4 STATIC ${AP4_SOURCES})
target_include_directories(ap4 PUBLIC
  ${AP4_INCLUDE_DIRS}
)

# Use the statically linked C runtime library
if(MSVC)
  set_property(TARGET ap4 PROPERTY MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
  target_compile_definitions(ap4 PRIVATE -D_LIB)
endif()

# Apps
option(BUILD_APPS "Build example applications" ON)
if(BUILD_APPS)
file(GLOB BENTO4_APPS RELATIVE ${SOURCE_ROOT}/Apps ${SOURCE_ROOT}/Apps/*)
foreach(app ${BENTO4_APPS})
  string(TOLOWER ${app} binary_name)
  list(APPEND BENTO4_APPS_LOWERCASE ${binary_name})
  add_executable(${binary_name} ${SOURCE_ROOT}/Apps/${app}/${app}.cpp)
  target_link_libraries(${binary_name} ap4)

  if(MSVC)
    set_property(TARGET ${binary_name} PROPERTY MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
    target_compile_definitions(${binary_name} PRIVATE -D_CONSOLE)
  endif()
endforeach()
endif(BUILD_APPS)

# Install
include(GNUInstallDirs)
set(config_install_dir "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")
set(generated_dir "${CMAKE_CURRENT_BINARY_DIR}/generated")
set(version_config "${generated_dir}/${PROJECT_NAME}ConfigVersion.cmake")
set(project_config "${generated_dir}/${PROJECT_NAME}Config.cmake")
set(TARGETS_EXPORT_NAME "${PROJECT_NAME}Targets")
set(namespace "${PROJECT_NAME}::")

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    "${version_config}" COMPATIBILITY SameMajorVersion
)

configure_package_config_file(
    "Build/cmake/Config.cmake.in"
    "${project_config}"
    INSTALL_DESTINATION "${config_install_dir}"
)

install(
    TARGETS ap4 ${BENTO4_APPS_LOWERCASE}
    EXPORT "${TARGETS_EXPORT_NAME}"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
    INCLUDES DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
)

install(
    FILES ${AP4_HEADERS}
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/bento4"
)

install(
    FILES "${project_config}" "${version_config}"
    DESTINATION "${config_install_dir}"
)

install(
    EXPORT "${TARGETS_EXPORT_NAME}"
    NAMESPACE "${namespace}"
    DESTINATION "${config_install_dir}"
)

=== src/CMakeLists.txt ===
set(SOURCES
  AdaptiveByteStream.cpp
  main.cpp
  oscompat.cpp
  Session.cpp
  SrvBroker.cpp
  CompKodiProps.cpp
  CompSettings.cpp
  Stream.cpp
  aes_decrypter.cpp
)

set(HEADERS
  AdaptiveByteStream.h
  main.h
  oscompat.h
  Session.h
  SrvBroker.h
  CompKodiProps.h
  CompResources.h
  CompSettings.h
  Stream.h
  aes_decrypter.h
  Iaes_decrypter.h
)

add_dir_sources(SOURCES HEADERS)

add_subdirectory(codechandler)
add_subdirectory(common)
add_subdirectory(decrypters)
add_subdirectory(demuxers)
add_subdirectory(parser)
add_subdirectory(samplereader)
add_subdirectory(utils)

=== lib/cdm/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(cdm_library)

if(WIN32)
  set(CDMTYPE "win.cc")
elseif(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  set(CDMTYPE "mac.mm")
else()
  set(CDMTYPE "posix.cc")
endif()

add_library(cdm_library STATIC
  cdm/debug.cpp
  cdm/base/native_library.cc
  cdm/base/native_library_${CDMTYPE}
  cdm/media/cdm/cdm_adapter.cc
  cdm/media/cdm/cdm_adapter.h
)

target_include_directories(cdm_library PUBLIC ${PROJECT_SOURCE_DIR})

set_target_properties(cdm_library PROPERTIES POSITION_INDEPENDENT_CODE True)

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  target_link_libraries(cdm_library "-framework CoreFoundation")
endif()

source_group_by_folder(cdm_library)

=== lib/mpegts/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(mpegts)

if(TSDEMUX_DEBUG)
  add_definitions(-DTSDEMUX_DEBUG)
endif(TSDEMUX_DEBUG)

add_library(mpegts STATIC
  mpegts/debug.cpp
  mpegts/debug.h
  mpegts/elementaryStream.cpp
  mpegts/elementaryStream.h
  mpegts/ES_AAC.cpp
  mpegts/ES_AAC.h
  mpegts/ES_AC3.cpp
  mpegts/ES_AC3.h
  mpegts/ES_h264.cpp
  mpegts/ES_h264.h
  mpegts/ES_hevc.cpp
  mpegts/ES_hevc.h
  mpegts/ES_MPEGAudio.cpp
  mpegts/ES_MPEGAudio.h
  mpegts/ES_MPEGVideo.cpp
  mpegts/ES_MPEGVideo.h
  mpegts/ES_Subtitle.cpp
  mpegts/ES_Subtitle.h
  mpegts/ES_Teletext.cpp
  mpegts/ES_Teletext.h
  mpegts/mutex.h
  mpegts/tsDemuxer.cpp
  mpegts/tsDemuxer.h
  mpegts/tsPacket.h
  mpegts/tsTable.h
  mpegts/bitstream.cpp
  mpegts/bitstream.h
)

target_include_directories(mpegts PRIVATE ${PROJECT_SOURCE_DIR}/mpegts PUBLIC ${PROJECT_SOURCE_DIR})

set_target_properties(mpegts PROPERTIES POSITION_INDEPENDENT_CODE True)

source_group_by_folder(mpegts)

=== src/common/CMakeLists.txt ===
set(SOURCES
  AdaptationSet.cpp
  AdaptiveCencSampleDecrypter.cpp
  AdaptiveStream.cpp
  AdaptiveTree.cpp
  AdaptiveTreeFactory.cpp
  AdaptiveUtils.cpp
  Chooser.cpp
  ChooserAskQuality.cpp
  ChooserDefault.cpp
  ChooserFixedRes.cpp
  ChooserManualOSD.cpp
  ChooserTest.cpp
  CommonAttribs.cpp
  CommonSegAttribs.cpp
  Period.cpp
  Representation.cpp
  ReprSelector.cpp
  Segment.cpp
  SegmentBase.cpp
  SegmentList.cpp
  SegTemplate.cpp
)

set(HEADERS
  AdaptationSet.h
  AdaptiveCencSampleDecrypter.h
  AdaptiveDecrypter.h
  AdaptiveStream.h
  AdaptiveTree.h
  AdaptiveTreeFactory.h
  AdaptiveUtils.h
  Chooser.h
  ChooserAskQuality.h
  ChooserDefault.h
  ChooserFixedRes.h
  ChooserManualOSD.h
  ChooserTest.h
  CommonAttribs.h
  CommonSegAttribs.h
  Period.h
  Representation.h
  ReprSelector.h
  Segment.h
  SegmentBase.h
  SegmentList.h
  SegTemplate.h
)

add_dir_sources(SOURCES HEADERS)

=== src/decrypters/CMakeLists.txt ===
set(SOURCES
  DrmFactory.cpp
  Helpers.cpp
)

set(HEADERS
  DrmFactory.h
  Helpers.h
  IDecrypter.h
)

add_dir_sources(SOURCES HEADERS)

add_subdirectory(clearkey)
if(NOT CORE_SYSTEM_NAME STREQUAL ios AND NOT CORE_SYSTEM_NAME STREQUAL darwin_embedded)
  if(CORE_SYSTEM_NAME STREQUAL android)
    add_subdirectory(widevineandroid)
  else()
    add_subdirectory(widevine)
  endif()
endif()

=== src/demuxers/CMakeLists.txt ===
set(SOURCES
  ADTSReader.cpp
  TSReader.cpp
  WebmReader.cpp
)

set(HEADERS
  ADTSReader.h
  TSReader.h
  WebmReader.h
)

add_dir_sources(SOURCES HEADERS)

=== src/parser/CMakeLists.txt ===
set(SOURCES
  CodecParser.cpp
  DASHTree.cpp
  HLSTree.cpp
  SmoothTree.cpp
  PRProtectionParser.cpp
)

set(HEADERS
  CodecParser.h
  DASHTree.h
  HLSTree.h
  SmoothTree.h
  PRProtectionParser.h
)

add_dir_sources(SOURCES HEADERS)

=== src/samplereader/CMakeLists.txt ===
set(SOURCES
  ADTSSampleReader.cpp
  FragmentedSampleReader.cpp
  SampleReaderFactory.cpp
  SubtitleSampleReader.cpp
  TSSampleReader.cpp
  WebmSampleReader.cpp
)

set(HEADERS
  ADTSSampleReader.h
  FragmentedSampleReader.h
  SampleReader.h
  SampleReaderFactory.h
  SubtitleSampleReader.h
  TSSampleReader.h
  WebmSampleReader.h
)

add_dir_sources(SOURCES HEADERS)

=== src/test/CMakeLists.txt ===
set(BINARY ${CMAKE_PROJECT_NAME}_test)

find_package( Threads )

add_definitions(-DINPUTSTREAM_TEST_BUILD)

add_executable(${BINARY}
    TestMain.cpp
    TestDASHTree.cpp
    TestHLSTree.cpp
    TestSmoothTree.cpp
    TestHelper.cpp
    TestUtils.cpp
    ../decrypters/Helpers.cpp
    ../parser/DASHTree.cpp
    ../parser/HLSTree.cpp
    ../parser/SmoothTree.cpp
    ../parser/PRProtectionParser.cpp
    ../common/AdaptationSet.cpp
    ../common/AdaptiveStream.cpp
    ../common/AdaptiveTree.cpp
    ../common/AdaptiveTreeFactory.cpp
    ../common/AdaptiveUtils.cpp
    ../common/Chooser.cpp
    ../common/ChooserAskQuality.cpp
    ../common/ChooserDefault.cpp
    ../common/ChooserFixedRes.cpp
    ../common/ChooserManualOSD.cpp
    ../common/ChooserTest.cpp
    ../common/CommonAttribs.cpp
    ../common/CommonSegAttribs.cpp
    ../common/Period.cpp
    ../common/Representation.cpp
    ../common/ReprSelector.cpp
    ../common/Segment.cpp
    ../common/SegmentBase.cpp
    ../common/SegmentList.cpp
    ../common/SegTemplate.cpp
    ../oscompat.cpp
    ../SrvBroker.cpp
    ../CompSettings.cpp
    ../CompKodiProps.cpp
    ../utils/Base64Utils.cpp
    ../utils/CharArrayParser.cpp
    ../utils/CurlUtils.cpp
    ../utils/DigestMD5Utils.cpp
    ../utils/FileUtils.cpp
    ../utils/StringUtils.cpp
    ../utils/UrlUtils.cpp
    ../utils/Utils.cpp
    ../utils/XMLUtils.cpp
    )

target_link_libraries(${BINARY} PRIVATE ${BENTO4_LIBRARIES} ${PUGIXML_LIBRARIES} ${GTEST_LIBRARIES} Threads::Threads ${CMAKE_DL_LIBS})

set(TEST_DATA_DIR "${CMAKE_SOURCE_DIR}/src/test/manifests")
add_test(NAME manifest_tests COMMAND ${BINARY} "${TEST_DATA_DIR}")

=== src/utils/CMakeLists.txt ===
set(SOURCES
  Base64Utils.cpp
  CharArrayParser.cpp
  CurlUtils.cpp
  DigestMD5Utils.cpp
  FileUtils.cpp
  StringUtils.cpp
  UrlUtils.cpp
  Utils.cpp
  XMLUtils.cpp
)

set(HEADERS
  Base64Utils.h
  CharArrayParser.h
  CryptoUtils.h
  CurlUtils.h
  DigestMD5Utils.h
  FileUtils.h
  log.h
  StringUtils.h
  UrlUtils.h
  Utils.h
  XMLUtils.h
)

add_dir_sources(SOURCES HEADERS)

=== src/decrypters/clearkey/CMakeLists.txt ===
set(SOURCES
  ClearKeyCencSingleSampleDecrypter.cpp
  ClearKeyDecrypter.cpp
)

set(HEADERS
  ClearKeyCencSingleSampleDecrypter.h
  ClearKeyDecrypter.h
)

add_dir_sources(SOURCES HEADERS)

=== debian/changelog ===
kodi-inputstream-adaptive (21.5.16+ds-1) unstable; urgency=high

  * New upstream version 21.5.16+ds

 -- Vasyl Gello <vasek.gello@gmail.com>  Fri, 10 Oct 2025 06:39:56 +0000

kodi-inputstream-adaptive (21.5.9+ds-1.1) unstable; urgency=medium

  * Backport upstream fix for FTBFS with GCC 15. (Closes: #1097072)

 -- Adrian Bunk <bunk@debian.org>  Sun, 21 Sep 2025 21:30:56 +0300

=== debian/control ===
Source: kodi-inputstream-adaptive
Priority: optional
Section: libs
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Vasyl Gello <vasek.gello@gmail.com>
Build-Depends: debhelper-compat (= 13)
Build-Depends-Arch: dh-sequence-kodiaddon (>= 2:21~),
 cmake,
 libexpat1-dev,
 libgtest-dev (>= 1.10.0~),
 libpugixml-dev,
 libwebm-dev,
 rapidjson-dev,
 pkg-config
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/multimedia-team/kodi-media-center/kodi-inputstream-adaptive
Vcs-Git: https://salsa.debian.org/multimedia-team/kodi-media-center/kodi-inputstream-adaptive.git -b debian/sid
Homepage: https://kodi.tv/

Package: kodi-inputstream-adaptive
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 ${kodi:INPUTSTREAMAPI}
Description: Adaptive inputstream addon for Kodi
 This package allows playing HLS/DASH/smoothstream streams in Kodi.
 .
 It is part of the official kodi repository.
 .
 Its primary use is to play DRM-protected with decryptors supplied
 by other addons (like Netflix or other paid video services).

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# basilgello: Fix build on armel and other architectures
# silently requiring libatomic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed -latomic -Wl,--as-needed -lpthread

BENTO4_COMPONENT = bento4-embedded

# bento4 configuration options
# basilgello: we build embedded libap4 as external to kodi-i-a
# because the kodi-i-a upstream requires us either to specify CMake
# toolchain file or build libap4 before kodi-i-a is configured
#
# Two CMake variables are injected into CMake cache to disable
# `find_library(BENTO4_LIBRARY` and `find_include_dir(BENTO4_INCLUDE_DIR`
# processing: BENTO4_LIBRARY and BENTO4_INCLUDE_DIR.
#
# See FindBento4.cmake and --trace-expand CMake log for
# the underlying logic
BENTO4_OPTS=\
-DCMAKE_INSTALL_PREFIX=/install \
-DCMAKE_INSTALL_INCLUDEDIR=include \
-DCMAKE_INSTALL_LIBDIR=lib \
-DBUILD_APPS=OFF

%:
	dh $@

bento4/install/lib/libap4.a:
	# Produce libap4.a for host architecture
	dh_auto_configure \
		--sourcedir "$(CURDIR)/$(BENTO4_COMPONENT)" \
		--builddir "$(CURDIR)/bento4/build" \
		-- $(BENTO4_OPTS)
	dh_auto_build \
		--sourcedir "$(CURDIR)/$(BENTO4_COMPONENT)" \
		--builddir "$(CURDIR)/bento4/build"
	dh_auto_install \
		--builddir "$(CURDIR)/bento4/build" \
		--destdir "$(CURDIR)/bento4"

override_dh_clean:
	dh_clean \
		bento4/

override_dh_auto_configure: bento4/install/lib/libap4.a
	# basilgello: -DCMAKE_INSTALL_DIR silences Kodi buildsystem
	# warning triggered by dh_configure unnecessarily overriding
	# install directory
	# -DUSE_LTO=0 disables LTO and makes build reproducible
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=ReleaseWithDebInfo \
            -DENABLE_INTERNAL_BENTO4=0 \
            -DBUILD_SHARED_LIBS=1 \
            -DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)/kodi \
            -DBENTO4_LIBRARY:FILEPATH=$(CURDIR)/bento4/install/lib/libap4.a \
            -DBENTO4_INCLUDE_DIR:PATH=$(CURDIR)/bento4/install/include \
            -DUSE_LTO=0

=== debian/watch ===
version=4

# Release git tags
# Kodi addons are bound to internal Kodi API versions so the version
# initially built for older Kodi suite (like Matrix or Nexus) may run 
# on newer Kodi (like Omega) if corresponding internal API version
# has not been changed.
#
# This flexibility introduces minor inconvenience to Debian package
# builders as uscan(1) typically operates on single suite of upstream
# tags.
#
# To mitigate addon updates not found, it is possible to specify multiple
# allowed codenames in regexp and tweak uversionmangle to strip the
# dot-suitename from the rersulting tarball name
#
# For debian/sid and other non-experimental branches, the list of codenames
# must start with the Kodi suite name the API was ast changed and end with
# a current Kodi suite being packaged, like:
#
# uversionmangle=s/\.(Nexus|Omega)//, \
# refs/tags/@ANY_VERSION@-(Nexus|Omega) \
#
# for Omega.
#
# For debian/experimental, the list of codenames must have only one suite
# matching current master (i.e Piers if Omega is currently shipped in debian/sid)
# This way only package versions targeting kodi-next will land into
# debian/experimental while all earlier compatible versions will be caught by
# debian/sid watchfile.
#

# Release git tags

# TODO: Change allowed Kodi codenames in refs/tags and uversionmangle
# before packaging next Kodi major release!

opts="mode=git, \
      pgpmode=none, \
      repack, \
      repacksuffix=+ds, \
      compression=xz, \
      uversionmangle=s/\.(Nexus|Omega)//, \
      dversionmangle=auto" \
https://github.com/xbmc/inputstream.adaptive \
refs/tags/@ANY_VERSION@-(Nexus|Omega) \
debian

# Bento4

opts="component=bento4-embedded, \
      mode=git, \
      pgpmode=none, \
      repack, \
      compression=xz, \
      uversionmangle=s/\.(Nexus|Omega)//, \
      dversionmangle=auto" \
https://github.com/xbmc/Bento4 \
refs/tags/@ANY_VERSION@-(Nexus|Omega) \
ignore
